com.license4j

## Class LicenseText

- java.lang.Object
- - com.license4j.LicenseText

-     public class LicenseText
      extends java.lang.Object

  License text class.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `TYPE_FLOATING_LICENSE_FILE`
    `static int` | `TYPE_LICENSE_FILE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LicenseText()` LicenseText constructor, creates an empty License object.
    `LicenseText(java.lang.String licenseString, java.lang.String publicKey)` License constructor, creates license text by loading given license text string.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `getActivationCompletedDateTime()` Get activation completed date time.
    `int` | `getActivationHardwareIDSelection()` Get activation hardware ID selection value.
    `long` | `getActivationID()` Get activation ID if activation is completed.
    `int` | `getActivationPeriod()` Get activation period if defined.
    `int` | `getActivationReturnType()` Return activation return type.
    `java.lang.String` | `getContent(java.lang.String publickey)` Returns license text string.
    `java.lang.String` | `getCustomSignedFeature(java.lang.String key)` Get custom signed feature.
    `int` | `getCustomSignedFeatureConcurrentQuantity(java.lang.String key)` Get custom signed feature concurrent quantity.
    `java.util.HashMap` | `getCustomSignedFeatures()` Get custom signed features in a hashmap.
    `java.lang.String` | `getCustomUnsignedFeature(java.lang.String key)` Get custom unsigned feature.
    `java.util.HashMap` | `getCustomUnsignedFeatures()` Get custom unsigned features in a hashmap.
    `int` | `getDatetimeCheck()` Get if online date time check is enabled.
    `java.lang.String` | `getDatetimeNTPServer()` Get NTP server which will be used for online date time check if enabled.
    `int` | `getDatetimeNTPServerTimeout()` Get NTP server connection timeout value which will be used for online date time check if enabled.
    `java.lang.String` | `getDatetimeWebServer()` Get web server which will be used for online date time check if enabled.
    `int` | `getDatetimeWebServerTimeout()` Get web server connection timeout value which will be used for online date time check if enabled.
    `int` | `getFloatingLicenseCheckPeriod()` Get floating license check period in minutes, runtime library runs a timer to check for license availability.
    `int` | `getFloatingLicenseServerConnectionCheckPeriod()` Get floating license server connection check period in minutes, runtime library runs a timer to check for floating license server availability.
    `int` | `getFloatingLicenseSupersedeAllLicenses()` Get value for supersede all old license settings.
    `java.lang.String` | `getFloatingLicenseSupersedeLicenses()` Get floating licenses IDs which is superseded by this license.
    `int` | `getLicenseActivationDaysRemaining(java.util.Date currentDate)` Returns license activation days remaining.
    `java.util.Date` | `getLicenseExpireDate()` Returns license expiration date.
    `int` | `getLicenseExpireDaysRemaining(java.util.Date currentDate)` Gives number of days left before expiration if license validity period is defined.
    `int` | `getLicenseFileType()` Returns license text type, either normal license text or floating license text.
    `long` | `getLicenseGenerationDateTime()` Return license generation date time if set.
    `java.lang.String` | `getLicenseHardwareID()` If generated license is node-locked, locked computer hardware ID returns.
    `long` | `getLicenseID()` Return unique license id.
    `java.util.Date` | `getLicenseMaintenanceExpireDate()` Returns license maintenance expire date.
    `int` | `getLicenseMaintenanceExpireDaysRemaining(java.util.Date currentDate)` Returns license maintenance expiration days remaining.
    `int` | `getLicenseMaintenancePeriod()` Get license maintenence validity period in number of days.
    `java.lang.String` | `getLicenseProductName()` Get product name which license is generated for.
    `java.util.Properties` | `getLicenseProperties()` Method returns all raw license properties.
    `java.lang.String` | `getLicensePublicKey()` Return license public key, public key is only found in floating license text.
    `int` | `getLicenseQuantity()` Return license quantity.
    `java.lang.String` | `getLicenseSignature()` Return license signature after generation.
    `int` | `getLicenseValidityPeriod()` Get license validity period in number of days.
    `java.lang.String` | `getLicenseValidProductEdition()` Get product edition which license is generated and only valid for.
    `java.lang.String` | `getLicenseValidProductID()` Get product ID which license is generated and only valid for.
    `java.lang.String` | `getLicenseValidProductVersion()` Get product version which license is generated and only valid for.
    `int` | `getOnlineKeyMaxFailureCount()` Get online license key floating over internet maximum failure count.
    `int` | `getOnlineKeyMaxInactivePeriod()` Get online license key floating over internet maximum inactive period before removing lease.
    `java.lang.String` | `getUserCity()` Get license owner user city name.
    `java.lang.String` | `getUserCompany()` Get license owner company name.
    `java.lang.String` | `getUserCountry()` Get license owner user country name.
    `java.lang.String` | `getUserEMail()` Get license owner user e-mail address.
    `java.lang.String` | `getUserFax()` Get license owner user fax number.
    `java.lang.String` | `getUserFullName()` Get license owner user full name.
    `java.lang.String` | `getUserRegisteredTo()` Get user name which license is registered to.
    `java.lang.String` | `getUserStreet()` Get license owner user street address.
    `java.lang.String` | `getUserTelephone()` Get license owner user telephone number.
    `java.lang.String` | `getUserZipCode()` Get license owner user zip code.
    `boolean` | `isActivationCompleted()` Return is activation is completed.
    `boolean` | `isActivationRequired()` Return if activation is required for license.
    `boolean` | `isDatetimeQueryLocalADServer()` Get if active directory server query is enabled.
    `boolean` | `isFloatingLicenseAllowMultipleInstances()` Get if floating license allows multiple instances on same host with same user.
    `boolean` | `isGenerationDateTimeInFuture(java.util.Date currentDate)` Returns if license generation date and time is in the future.
    `void` | `removeCustomSignedFeature(java.lang.String name)` Remove a custom signed feature.
    `void` | `removeCustomUnsignedFeature(java.lang.String name)` Remove a custom unsigned feature.
    `void` | `setActivationCompleted(boolean activationCompleted)` Set if license activation is completed.
    `void` | `setActivationCompletedDateTime(long activationCompletedDateTime)` Set activation completed date time.
    `void` | `setActivationHardwareIDSelection(int activationHardwareIDSelection)` Set activation hardware ID selection value.
    `void` | `setActivationID(long activationID)` Set activation ID if activation is completed.
    `void` | `setActivationPeriod(int activationPeriod)` Set activation period.
    `void` | `setActivationRequired(boolean activationRequired)` Set if license requires activation.
    `void` | `setActivationReturnType(int activationReturnType)` Set activation return type.
    `void` | `setCustomSignedFeature(java.lang.String name, java.lang.String value)` Set a custom signed feature.
    `void` | `setCustomSignedFeatures(java.util.HashMap customSignedFeaturesHashMap)` Set custom signed features in a hashmap.
    `void` | `setCustomUnsignedFeature(java.lang.String name, java.lang.String value)` Set a custom unsigned feature.
    `void` | `setCustomUnsignedFeatures(java.util.HashMap customUnsignedFeaturesHashMap)` Set custom unsigned features in a hashmap.
    `void` | `setDatetimeCheck(int datetimeCheck)` Set if online date time check is enabled.
    `void` | `setDatetimeNTPServer(java.lang.String datetimeNTPServer)` Set NTP server which will be used for online date time check if enabled.
    `void` | `setDatetimeNTPServerTimeout(int datetimeNTPServerTimeout)` Set NTP server connection timeout value which will be used for online date time check if enabled.
    `void` | `setDatetimeQueryLocalADServer(boolean datetimeQueryLocalADServer)` Set active directory date time query if found in local network.
    `void` | `setDatetimeWebServer(java.lang.String datetimeWebServer)` Set web server which will be used for online date time check if enabled.
    `void` | `setDatetimeWebServerTimeout(int datetimeWebServerTimeout)` Set web server connection timeout value which will be used for online date time check if enabled.
    `void` | `setFloatingLicenseAllowMultipleInstances(boolean floatingLicenseAllowMultipleInstances)` Set if floating license allows multiple instances on same host with same user.
    `void` | `setFloatingLicenseCheckPeriod(int floatingLicenseCheckPeriod)` Set floating license check period in minutes, runtime library runs a timer to check for license availability.
    `void` | `setFloatingLicenseServerConnectionCheckPeriod(int floatingLicenseServerConnectionCheckPeriod)` Set floating license server connection check period in minutes, runtime library runs a timer to check for floating license server availability.
    `void` | `setFloatingLicenseSupersedeAllLicenses(int floatingLicenseSupersedeAllLicenses)` Set value for supersede all old license settings.
    `void` | `setFloatingLicenseSupersedeLicenses(java.lang.String floatingLicenseSupersedeLicenses)` Set floating licenses IDs which is superseded by this license.
    `void` | `setLicenseFileType(int licenseFileType)` Should be only used if generating floating license text.
    `void` | `setLicenseGenerationDateTime(long licenseGenerationDateTime)` Set license generation date time, long value from epoch.
    `void` | `setLicenseHardwareID(java.lang.String licenseHardwareID)` To generate a node-locked license hardware ID string obtained from HardwareID class or HardwareIDViewer application is given.
    `void` | `setLicenseID(long licenseID)` Set unique license id, if not set it is auto generated.
    `void` | `setLicenseMaintenancePeriod(int licenseMaintenancePeriod)` Set license maintenance validity period in number of days.
    `void` | `setLicenseProductName(java.lang.String licenseProductName)` Set product name which license is generated for.
    `void` | `setLicensePublicKey(java.lang.String licensePublicKey)` Set license public key, public key should only be set for floating license text.
    `void` | `setLicenseQuantity(int licenseQuantity)` Set license quantity.
    `void` | `setLicenseSignature(java.lang.String licenseSignature)` License signature is auto generated, do not set it.
    `void` | `setLicenseValidityPeriod(int licenseValidityPeriod)` Set license validity period in number of days.
    `void` | `setLicenseValidProductEdition(java.lang.String licenseValidProductEdition)` Set product edition which license is generated and only valid for.
    `void` | `setLicenseValidProductID(java.lang.String licenseValidProductID)` Set product ID which license is generated and only valid for.
    `void` | `setLicenseValidProductVersion(java.lang.String licenseValidProductVersion)` Set product version which license is generated and only valid for.
    `void` | `setOnlineKeyMaxFailureCount(int onlineKeyMaxFailureCount)` Set online license key floating over internet maximum failure count.
    `void` | `setOnlineKeyMaxInactivePeriod(int onlineKeyMaxInactivePeriod)` Set online license key floating over internet maximum inactive period before removing lease.
    `void` | `setUserCity(java.lang.String userCity)` Set license owner user city name.
    `void` | `setUserCompany(java.lang.String userCompany)` Set license owner company name.
    `void` | `setUserCountry(java.lang.String userCountry)` Set license owner user country name.
    `void` | `setUserEMail(java.lang.String userEMail)` Set license owner user e-mail address.
    `void` | `setUserFax(java.lang.String userFax)` Set license owner user fax number.
    `void` | `setUserFullName(java.lang.String userFullName)` Set license owner user full name.
    `void` | `setUserRegisteredTo(java.lang.String userRegisteredTo)` Set user name which license is registered to.
    `void` | `setUserStreet(java.lang.String userStreet)` Set license owner user street address.
    `void` | `setUserTelephone(java.lang.String userTelephone)` Set license owner uer telephone number.
    `void` | `setUserZipCode(java.lang.String userZipCode)` Set license owner user zip code.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TYPE_LICENSE_FILE

          public static final int TYPE_LICENSE_FILE

      See Also:
        Constant Field Values

    - #### TYPE_FLOATING_LICENSE_FILE

          public static final int TYPE_FLOATING_LICENSE_FILE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### LicenseText

          public LicenseText()

      LicenseText constructor, creates an empty License object.

    - #### LicenseText

          public LicenseText(java.lang.String licenseString,
                     java.lang.String publicKey)
                      throws LicenseSecurityException

      License constructor, creates license text by loading given license text string.
      Parameters:
        `licenseString` -
        `publicKey` -
      Throws:
        `LicenseSecurityException`

  - ### Method Detail

    - #### getContent

          public java.lang.String getContent(java.lang.String publickey)
                                      throws LicenseSecurityException

      Returns license text string.
      Parameters:
        `publickey` -
      Returns:
        license string
      Throws:
        `LicenseSecurityException`

    - #### getLicenseProperties

          public java.util.Properties getLicenseProperties()

      Method returns all raw license properties. Actually you will not need this method because all license features has its own get and set methods, you can use this just for displaying or debugging something.
      Returns:
        a Properties object including all license features defined.

    - #### getLicenseExpireDaysRemaining

          public int getLicenseExpireDaysRemaining(java.util.Date currentDate)

      Gives number of days left before expiration if license validity period is defined.
      Parameters:
        `currentDate` -
      Returns:
        number of remaining days, 0 if license expired, -1 if expire days not defined in license.

    - #### getLicenseExpireDate

          public java.util.Date getLicenseExpireDate()

      Returns license expiration date.
      Returns:
        date

    - #### isGenerationDateTimeInFuture

          public boolean isGenerationDateTimeInFuture(java.util.Date currentDate)

      Returns if license generation date and time is in the future.
      Parameters:
        `currentDate` -
      Returns:
        boolean

    - #### getLicenseMaintenanceExpireDaysRemaining

          public int getLicenseMaintenanceExpireDaysRemaining(java.util.Date currentDate)

      Returns license maintenance expiration days remaining.
      Parameters:
        `currentDate` - if null new Date() is used.
      Returns:
        days remaining before activation

    - #### getLicenseMaintenanceExpireDate

          public java.util.Date getLicenseMaintenanceExpireDate()

      Returns license maintenance expire date.
      Returns:
        date

    - #### getLicenseActivationDaysRemaining

          public int getLicenseActivationDaysRemaining(java.util.Date currentDate)

      Returns license activation days remaining.
      Parameters:
        `currentDate` -
      Returns:
        days

    - #### getLicenseFileType

          public int getLicenseFileType()

      Returns license text type, either normal license text or floating license text.
      Returns:
        constants TYPE_LICENSE_FILE or TYPE_FLOATING_LICENSE_FILE

    - #### setLicenseFileType

          public void setLicenseFileType(int licenseFileType)

      Should be only used if generating floating license text. Parameter constants are TYPE_LICENSE_FILE or TYPE_FLOATING_LICENSE_FILE
      Parameters:
        `licenseFileType` -

    - #### getUserRegisteredTo

          public java.lang.String getUserRegisteredTo()

      Get user name which license is registered to.
      Returns:
        userRegisteredTo

    - #### setUserRegisteredTo

          public void setUserRegisteredTo(java.lang.String userRegisteredTo)

      Set user name which license is registered to.
      Parameters:
        `userRegisteredTo` -

    - #### getUserFullName

          public java.lang.String getUserFullName()

      Get license owner user full name.
      Returns:
        userFullName

    - #### setUserFullName

          public void setUserFullName(java.lang.String userFullName)

      Set license owner user full name.
      Parameters:
        `userFullName` -

    - #### getUserEMail

          public java.lang.String getUserEMail()

      Get license owner user e-mail address.
      Returns:
        userEMail

    - #### setUserEMail

          public void setUserEMail(java.lang.String userEMail)

      Set license owner user e-mail address.
      Parameters:
        `userEMail` -

    - #### getUserCompany

          public java.lang.String getUserCompany()

      Get license owner company name.
      Returns:
        userCompany

    - #### setUserCompany

          public void setUserCompany(java.lang.String userCompany)

      Set license owner company name.
      Parameters:
        `userCompany` -

    - #### getUserTelephone

          public java.lang.String getUserTelephone()

      Get license owner user telephone number.
      Returns:
        userTelephone

    - #### setUserTelephone

          public void setUserTelephone(java.lang.String userTelephone)

      Set license owner uer telephone number.
      Parameters:
        `userTelephone` -

    - #### getUserFax

          public java.lang.String getUserFax()

      Get license owner user fax number.
      Returns:
        userFax

    - #### setUserFax

          public void setUserFax(java.lang.String userFax)

      Set license owner user fax number.
      Parameters:
        `userFax` -

    - #### getUserStreet

          public java.lang.String getUserStreet()

      Get license owner user street address.
      Returns:
        userStreet

    - #### setUserStreet

          public void setUserStreet(java.lang.String userStreet)

      Set license owner user street address.
      Parameters:
        `userStreet` -

    - #### getUserCity

          public java.lang.String getUserCity()

      Get license owner user city name.
      Returns:
        userCity

    - #### setUserCity

          public void setUserCity(java.lang.String userCity)

      Set license owner user city name.
      Parameters:
        `userCity` -

    - #### getUserZipCode

          public java.lang.String getUserZipCode()

      Get license owner user zip code.
      Returns:
        userZipCode

    - #### setUserZipCode

          public void setUserZipCode(java.lang.String userZipCode)

      Set license owner user zip code.
      Parameters:
        `userZipCode` -

    - #### getUserCountry

          public java.lang.String getUserCountry()

      Get license owner user country name.
      Returns:
        userCountry

    - #### setUserCountry

          public void setUserCountry(java.lang.String userCountry)

      Set license owner user country name.
      Parameters:
        `userCountry` -

    - #### getLicenseID

          public long getLicenseID()

      Return unique license id.
      Returns:
        licenseID

    - #### setLicenseID

          public void setLicenseID(long licenseID)

      Set unique license id, if not set it is auto generated.
      Parameters:
        `licenseID` -

    - #### getLicenseGenerationDateTime

          public long getLicenseGenerationDateTime()

      Return license generation date time if set.
      Returns:
        licenseGenerationDateTime

    - #### setLicenseGenerationDateTime

          public void setLicenseGenerationDateTime(long licenseGenerationDateTime)

      Set license generation date time, long value from epoch.
      Parameters:
        `licenseGenerationDateTime` -

    - #### getLicenseHardwareID

          public java.lang.String getLicenseHardwareID()

      If generated license is node-locked, locked computer hardware ID returns.
      Returns:
        licenseHardwareID

    - #### setLicenseHardwareID

          public void setLicenseHardwareID(java.lang.String licenseHardwareID)

      To generate a node-locked license hardware ID string obtained from HardwareID class or HardwareIDViewer application is given. Hardware IDs obtained from different sources (hostname, ethernet, volume serial number, hdd serial number) can be combined with either && or || operands.
      Parameters:
        `licenseHardwareID` -

    - #### getLicenseQuantity

          public int getLicenseQuantity()

      Return license quantity.
      Returns:
        licenseQuantity

    - #### setLicenseQuantity

          public void setLicenseQuantity(int licenseQuantity)

      Set license quantity.
      Parameters:
        `licenseQuantity` -

    - #### getLicenseProductName

          public java.lang.String getLicenseProductName()

      Get product name which license is generated for.
      Returns:
        licenseProductName

    - #### setLicenseProductName

          public void setLicenseProductName(java.lang.String licenseProductName)

      Set product name which license is generated for.
      Parameters:
        `licenseProductName` -

    - #### getLicenseValidProductID

          public java.lang.String getLicenseValidProductID()

      Get product ID which license is generated and only valid for.
      Returns:
        licenseValidProductID

    - #### setLicenseValidProductID

          public void setLicenseValidProductID(java.lang.String licenseValidProductID)

      Set product ID which license is generated and only valid for.
      Parameters:
        `licenseValidProductID` -

    - #### getLicenseValidProductEdition

          public java.lang.String getLicenseValidProductEdition()

      Get product edition which license is generated and only valid for.
      Returns:
        licenseValidProductEdition

    - #### setLicenseValidProductEdition

          public void setLicenseValidProductEdition(java.lang.String licenseValidProductEdition)

      Set product edition which license is generated and only valid for.
      Parameters:
        `licenseValidProductEdition` -

    - #### getLicenseValidProductVersion

          public java.lang.String getLicenseValidProductVersion()

      Get product version which license is generated and only valid for.
      Returns:
        licenseValidProductEdition

    - #### setLicenseValidProductVersion

          public void setLicenseValidProductVersion(java.lang.String licenseValidProductVersion)

      Set product version which license is generated and only valid for.
      Parameters:
        `licenseValidProductVersion` -

    - #### getLicenseValidityPeriod

          public int getLicenseValidityPeriod()

      Get license validity period in number of days. License expires after defined number of days passed over generation date. So, expiration date is generation date + validity period
      Returns:
        licenseValidProductEdition

    - #### setLicenseValidityPeriod

          public void setLicenseValidityPeriod(int licenseValidityPeriod)

      Set license validity period in number of days. License expires after defined number of days passed over generation date. So, expiration date is generation date + validity period. e.g. If you want to generate 1 year valid license, set validity period to 365 days.
      Parameters:
        `licenseValidityPeriod` -

    - #### getLicenseMaintenancePeriod

          public int getLicenseMaintenancePeriod()

      Get license maintenence validity period in number of days. License maintenance expires after defined number of days passed over generation date. So, maintenance expiration date is generation date + maintenance period
      Returns:
        licenseValidProductEdition

    - #### setLicenseMaintenancePeriod

          public void setLicenseMaintenancePeriod(int licenseMaintenancePeriod)

      Set license maintenance validity period in number of days. License maintenance expires after defined number of days passed over generation date. So, maintenance expiration date is generation date + maintenance period. e.g. If you want to generate 1 year maintenance valid license, set maintenance period to 365 days.
      Parameters:
        `licenseMaintenancePeriod` -

    - #### isActivationRequired

          public boolean isActivationRequired()

      Return if activation is required for license.
      Returns:
        activationRequired

    - #### setActivationRequired

          public void setActivationRequired(boolean activationRequired)

      Set if license requires activation.
      Parameters:
        `activationRequired` -

    - #### isActivationCompleted

          public boolean isActivationCompleted()

      Return is activation is completed.
      Returns:
        activationCompleted

    - #### setActivationCompleted

          public void setActivationCompleted(boolean activationCompleted)

      Set if license activation is completed. If set to true, activationRequired is set to false, and activation period is set to 0.
      Parameters:
        `activationCompleted` -

    - #### getActivationCompletedDateTime

          public long getActivationCompletedDateTime()

      Get activation completed date time.
      Returns:
        activationCompletedDateTime

    - #### setActivationCompletedDateTime

          public void setActivationCompletedDateTime(long activationCompletedDateTime)

      Set activation completed date time.
      Parameters:
        `activationCompletedDateTime` -

    - #### getActivationPeriod

          public int getActivationPeriod()

      Get activation period if defined.
      Returns:
        activationPeriod

    - #### setActivationPeriod

          public void setActivationPeriod(int activationPeriod)

      Set activation period. It is number of days for activation process. After activation period is over, license must be activated.
      Parameters:
        `activationPeriod` -

    - #### getActivationReturnType

          public int getActivationReturnType()

      Return activation return type. There are two types of activation return type. The first one is activation code, it is a secure license key. The second one is license text. Integer values are 1 for activation code, and 2 for license text.
      Returns:
        activationReturnType

    - #### setActivationReturnType

          public void setActivationReturnType(int activationReturnType)

      Set activation return type. There are two types of activation return type. The first one is activation code, it is a secure license key. The second one is license text. Integer values are 1 for activation code, and 2 for license text.
      Parameters:
        `activationReturnType` -

    - #### getActivationHardwareIDSelection

          public int getActivationHardwareIDSelection()

      Get activation hardware ID selection value. It is an integer, and 1 for hardware ID from hostname; 2 for hardware ID from ethernet address; 3 for hardware ID from disk volume uuid; 4 for hardware ID from HDD serial number. A combination is used, and if && operand is used number is positive like 12, 13, 1234. If || operand is used number must be negative like -12, -13, -1234.
      Returns:
        activationHardwareIDSelection

    - #### setActivationHardwareIDSelection

          public void setActivationHardwareIDSelection(int activationHardwareIDSelection)

      Set activation hardware ID selection value. It is an integer, and 1 for hardware ID from hostname; 2 for hardware ID from ethernet address; 3 for hardware ID from disk volume uuid; 4 for hardware ID from HDD serial number. A combination is used, and if && operand is used number is positive like 12, 13, 1234. If || operand is used number must be negative like -12, -13, -1234.
      Parameters:
        `activationHardwareIDSelection` -

    - #### getDatetimeCheck

          public int getDatetimeCheck()

      Get if online date time check is enabled. 0 for false, 1 for true.
      Returns:
        datetimeCheck

    - #### setDatetimeCheck

          public void setDatetimeCheck(int datetimeCheck)

      Set if online date time check is enabled. 0 for false, 1 for true.
      Parameters:
        `datetimeCheck` -

    - #### getDatetimeNTPServer

          public java.lang.String getDatetimeNTPServer()

      Get NTP server which will be used for online date time check if enabled.
      Returns:
        datetimeNTPServer

    - #### setDatetimeNTPServer

          public void setDatetimeNTPServer(java.lang.String datetimeNTPServer)

      Set NTP server which will be used for online date time check if enabled.
      Parameters:
        `datetimeNTPServer` -

    - #### getDatetimeNTPServerTimeout

          public int getDatetimeNTPServerTimeout()

      Get NTP server connection timeout value which will be used for online date time check if enabled. Default is 1000 ms.
      Returns:
        datetimeNTPServer

    - #### setDatetimeNTPServerTimeout

          public void setDatetimeNTPServerTimeout(int datetimeNTPServerTimeout)

      Set NTP server connection timeout value which will be used for online date time check if enabled. Default is 1000 ms.
      Parameters:
        `datetimeNTPServerTimeout` -

    - #### getDatetimeWebServer

          public java.lang.String getDatetimeWebServer()

      Get web server which will be used for online date time check if enabled.
      Returns:
        datetimeNTPServer

    - #### setDatetimeWebServer

          public void setDatetimeWebServer(java.lang.String datetimeWebServer)

      Set web server which will be used for online date time check if enabled. Default value is http://online.license4j.com/d/time web page should return a single line of current time since epoch.
      Parameters:
        `datetimeWebServer` -

    - #### getDatetimeWebServerTimeout

          public int getDatetimeWebServerTimeout()

      Get web server connection timeout value which will be used for online date time check if enabled. Default is 1000 ms.
      Returns:
        datetimeNTPServer

    - #### setDatetimeWebServerTimeout

          public void setDatetimeWebServerTimeout(int datetimeWebServerTimeout)

      Set web server connection timeout value which will be used for online date time check if enabled. Default is 1000 ms.
      Parameters:
        `datetimeWebServerTimeout` -

    - #### isDatetimeQueryLocalADServer

          public boolean isDatetimeQueryLocalADServer()

      Get if active directory server query is enabled.
      Returns:
        datetimeQueryLocalADServer

    - #### setDatetimeQueryLocalADServer

          public void setDatetimeQueryLocalADServer(boolean datetimeQueryLocalADServer)

      Set active directory date time query if found in local network.
      Parameters:
        `datetimeQueryLocalADServer` -

    - #### getCustomSignedFeatures

          public java.util.HashMap getCustomSignedFeatures()

      Get custom signed features in a hashmap.
      Returns:
        customSignedFeatures

    - #### setCustomSignedFeatures

          public void setCustomSignedFeatures(java.util.HashMap customSignedFeaturesHashMap)

      Set custom signed features in a hashmap.
      Parameters:
        `customSignedFeaturesHashMap` -

    - #### getCustomUnsignedFeatures

          public java.util.HashMap getCustomUnsignedFeatures()

      Get custom unsigned features in a hashmap.
      Returns:
        customSignedFeatures

    - #### setCustomUnsignedFeatures

          public void setCustomUnsignedFeatures(java.util.HashMap customUnsignedFeaturesHashMap)

      Set custom unsigned features in a hashmap.
      Parameters:
        `customUnsignedFeaturesHashMap` -

    - #### getLicenseSignature

          public java.lang.String getLicenseSignature()

      Return license signature after generation.
      Returns:
        licenseSignature

    - #### setLicenseSignature

          public void setLicenseSignature(java.lang.String licenseSignature)

      License signature is auto generated, do not set it.
      Parameters:
        `licenseSignature` -

    - #### getLicensePublicKey

          public java.lang.String getLicensePublicKey()

      Return license public key, public key is only found in floating license text.
      Returns:
        licensePublicKey

    - #### setLicensePublicKey

          public void setLicensePublicKey(java.lang.String licensePublicKey)

      Set license public key, public key should only be set for floating license text.
      Parameters:
        `licensePublicKey` -

    - #### getFloatingLicenseCheckPeriod

          public int getFloatingLicenseCheckPeriod()

      Get floating license check period in minutes, runtime library runs a timer to check for license availability.
      Returns:
        floatingLicenseCheckPeriod

    - #### setFloatingLicenseCheckPeriod

          public void setFloatingLicenseCheckPeriod(int floatingLicenseCheckPeriod)

      Set floating license check period in minutes, runtime library runs a timer to check for license availability.
      Parameters:
        `floatingLicenseCheckPeriod` -

    - #### getFloatingLicenseServerConnectionCheckPeriod

          public int getFloatingLicenseServerConnectionCheckPeriod()

      Get floating license server connection check period in minutes, runtime library runs a timer to check for floating license server availability.
      Returns:
        floatingLicenseServerConnectionCheckPeriod

    - #### setFloatingLicenseServerConnectionCheckPeriod

          public void setFloatingLicenseServerConnectionCheckPeriod(int floatingLicenseServerConnectionCheckPeriod)

      Set floating license server connection check period in minutes, runtime library runs a timer to check for floating license server availability.
      Parameters:
        `floatingLicenseServerConnectionCheckPeriod` -

    - #### isFloatingLicenseAllowMultipleInstances

          public boolean isFloatingLicenseAllowMultipleInstances()

      Get if floating license allows multiple instances on same host with same user.
      Returns:
        floatingLicenseAllowMultipleInstances

    - #### setFloatingLicenseAllowMultipleInstances

          public void setFloatingLicenseAllowMultipleInstances(boolean floatingLicenseAllowMultipleInstances)

      Set if floating license allows multiple instances on same host with same user. If set to true, multiple instances of software on same computer will only consume single license.
      Parameters:
        `floatingLicenseAllowMultipleInstances` -

    - #### setCustomUnsignedFeature

          public void setCustomUnsignedFeature(java.lang.String name,
                                      java.lang.String value)

      Set a custom unsigned feature.
      Parameters:
        `name` -
        `value` -

    - #### setCustomSignedFeature

          public void setCustomSignedFeature(java.lang.String name,
                                    java.lang.String value)

      Set a custom signed feature.
      Parameters:
        `name` -
        `value` -

    - #### removeCustomSignedFeature

          public void removeCustomSignedFeature(java.lang.String name)

      Remove a custom signed feature.
      Parameters:
        `name` -

    - #### removeCustomUnsignedFeature

          public void removeCustomUnsignedFeature(java.lang.String name)

      Remove a custom unsigned feature.
      Parameters:
        `name` -

    - #### getOnlineKeyMaxInactivePeriod

          public int getOnlineKeyMaxInactivePeriod()

      Get online license key floating over internet maximum inactive period before removing lease.
      Returns:
        onlineKeyMaxInactivePeriod

    - #### setOnlineKeyMaxInactivePeriod

          public void setOnlineKeyMaxInactivePeriod(int onlineKeyMaxInactivePeriod)

      Set online license key floating over internet maximum inactive period before removing lease.
      Parameters:
        `onlineKeyMaxInactivePeriod` -

    - #### getOnlineKeyMaxFailureCount

          public int getOnlineKeyMaxFailureCount()

      Get online license key floating over internet maximum failure count.
      Returns:
        onlineKeyMaxInactivePeriod

    - #### setOnlineKeyMaxFailureCount

          public void setOnlineKeyMaxFailureCount(int onlineKeyMaxFailureCount)

      Set online license key floating over internet maximum failure count. When this number reached license lease removed.
      Parameters:
        `onlineKeyMaxFailureCount` -

    - #### getCustomUnsignedFeature

          public java.lang.String getCustomUnsignedFeature(java.lang.String key)

      Get custom unsigned feature.
      Parameters:
        `key` -
      Returns:
        value

    - #### getCustomSignedFeature

          public java.lang.String getCustomSignedFeature(java.lang.String key)

      Get custom signed feature.
      Parameters:
        `key` -
      Returns:
        value

    - #### getCustomSignedFeatureConcurrentQuantity

          public int getCustomSignedFeatureConcurrentQuantity(java.lang.String key)

      Get custom signed feature concurrent quantity. It is only applicable to Floating License Text type license and if quantity is defined for custom signed feature. It returns quantity or -1 if quantity is not enabled.
      Parameters:
        `key` -
      Returns:
        value

    - #### getActivationID

          public long getActivationID()

      Get activation ID if activation is completed.
      Returns:
        activationID

    - #### setActivationID

          public void setActivationID(long activationID)

      Set activation ID if activation is completed.
      Parameters:
        `activationID` -

    - #### getFloatingLicenseSupersedeLicenses

          public java.lang.String getFloatingLicenseSupersedeLicenses()

      Get floating licenses IDs which is superseded by this license.
      Returns:
        superseded license IDs

    - #### setFloatingLicenseSupersedeLicenses

          public void setFloatingLicenseSupersedeLicenses(java.lang.String floatingLicenseSupersedeLicenses)

      Set floating licenses IDs which is superseded by this license. License IDs should be separated with space.
      Parameters:
        `floatingLicenseSupersedeLicenses` -

    - #### getFloatingLicenseSupersedeAllLicenses

          public int getFloatingLicenseSupersedeAllLicenses()

      Get value for supersede all old license settings. 0 for no supersede. 1 for supersede if same product ID. 2 for supersede if same product ID and product edition. 3 for supersede same product ID and same product version. 4 for same product ID and product edition and product version.
      Returns:
        value for supersede all old licenses setting

    - #### setFloatingLicenseSupersedeAllLicenses

          public void setFloatingLicenseSupersedeAllLicenses(int floatingLicenseSupersedeAllLicenses)

      Set value for supersede all old license settings. 0 for no supersede. 1 for supersede if same product ID. 2 for supersede if same product ID and product edition. 3 for supersede same product ID and same product version. 4 for same product ID and product edition and product version.
      Parameters:
        `floatingLicenseSupersedeAllLicenses` -